<?php
/**
 * フロントエンド処理スクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_category_view
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * フロントエンドタスク処理
 */
class TASK_kingyoya_category_view {
	/**
	 * 表示処理
	 */
	function show($option, $id = null, $Itemid = null) {
		if (!$option) {
			trigger_error('Failed get option', E_USER_WARNING);
			return;
		}
		if (!preg_match('/^com_[0-9a-zA-Z_]+$/', $option)) {
			trigger_error("Failed get option: {$option}", E_USER_WARNING);
			return;
		}
		if (isset($Itemid)) {
			if (!$Itemid) {
				trigger_error('Failed get Itemid', E_USER_WARNING);
				return;
			} else if (!preg_match('/^[1-9][0-9]*$/', $Itemid)) {
				trigger_error("Failed get Itemid: {$Itemid}", E_USER_WARNING);
				return;
			}
		}

		global $mainframe;
		$params = new mosParameters($mainframe->menu->params);
		$template = $params->get('template');

		if (!isset($id)) {
			$id = $params->get('default_category');
		}
		if (!$id) {
			trigger_error('Failed get id', E_USER_WARNING);
			return;
		}
		if (!preg_match('/^[1-9][0-9]*$/', $id)) {
			trigger_error("Failed get id: {$id}", E_USER_WARNING);
			return;
		}
		$id = (int) $id;

		global $database;
		$category = new mosCategory($database);
		$result = $category->load($id);
		if (!$result) {
			trigger_error("Unknown category: {$id}", E_USER_WARNING);
			return;
		}

		$section = new mosSection($database);
		$result = $section->load($category->section);
		if (!$result) {
			trigger_error("Unknown section: {$category->section}", E_USER_WARNING);
			return;
		}

		$unpublish = $params->get('unpublish');
		if (!$unpublish && (!$category->published || !$section->published)) {
			trigger_error("Category unpublish: {$id}", E_USER_NOTICE);
			return;
		}

		if ($params->get('category_page_title')) {
			$mainframe->setPageTitle($category->title);
		} else if ($params->get('menu_page_title')) {
			$mainframe->setPageTitle($mainframe->menu->name);
		}

		require_once $mainframe->getPath('front_html', $option);
		$html = new HTML_kingyoya_category_view();
		$html->option = $option;
		$html->id = $id;
		$Itemid and $html->Itemid = $Itemid;
		$html->category = $category;
		$html->section = $section;
		$html->template = preg_replace('#<br */?>#i', "\n", $template);
		$html->show();

	}
}

if ($option === 'com_kingyoya_category_view') {
	TASK_kingyoya_category_view::show($option, isset($_REQUEST['id']) ? $_REQUEST['id'] : null, $Itemid);
}
